주제<template>
  <div class="bt-container">
    <section>
      <div id="topLabel">
        <div id="labelName">
          <h2 class="selected-lecture">테스트1강의 >&nbsp;</h2>
          <h2>주제 저널링</h2>
        </div>
        <span>
          <el-button
            id="excelExport"
            type="info"
            size="small"
            @click="onClick('EXPORT_EXCEL')"
          >
            {{ $t("JOURNALING.EXPORT_TO_EXCEL") }}
          </el-button>
        </span>
      </div>
      <div class="btn-switch">
        <el-button-group>
          <el-button
            v-if="firstView !== undefined"
            type="primary"
            :plain="
              $route.query.view === 'student' || $route.query.view === 'keyword'
            "
            size="small"
            @click="onClick('CHANGE_VIEW', 'default')"
          >
            {{ firstView }}{{ $t("JOURNALING.VIEWING") }}
          </el-button>
          <el-button
            type="primary"
            :plain="$route.query.view !== 'student'"
            size="small"
            @click="onClick('CHANGE_VIEW', 'student')"
          >
            {{ $t("JOURNALING.SHOW_BY_STD") }}
          </el-button>
          <el-button
            v-if="$route.query.itemId === undefined"
            type="primary"
            :plain="$route.query.view !== 'keyword'"
            size="small"
            @click="onClick('CHANGE_VIEW', 'keyword')"
          >
            {{ $t("JOURNALING.SHOW_BY_KEY") }}
          </el-button>
        </el-button-group>
      </div>
      <div class="btn-graph-onoff">
        <el-switch
          v-model="drawGraph"
          active-text="ON"
          inactive-text="GRAPH OFF"
          active-color="#4366ac"
          inactive-color="#4366ac"
        ></el-switch>
      </div>
      <line-chart
        v-if="drawGraph === true"
        :chartCategories="chartCategories"
        :chartData="chartData"
      />
      <el-table
        v-if="firstView !== '아이템' || firstColumn === '키워드 이름'"
        id="currentTable"
        :data="tableData"
        style="width: 100%"
      >
        <el-table-column :label="firstColumn" prop="name" align="center">
        </el-table-column>

        <el-table-column
          v-if="secondColumn !== undefined"
          :label="secondColumn"
          :prop="secondProp"
          align="center"
        >
        </el-table-column>

        <el-table-column
          :label="$t('DASHBOARD.ABS_PRTCP_STATUS')"
          width="210"
          prop="absolute_participation"
          align="center"
        >
        </el-table-column>

        <el-table-column
          :label="$t('DASHBOARD.RLT_PRTCP_STATUS')"
          width="205"
          prop="relative_participation"
          align="center"
        >
        </el-table-column>

        <el-table-column
          :label="$t('DASHBOARD.ABS_LEVEL_OF_UND')"
          width="250"
          prop="absolute_understanding"
          align="center"
        >
        </el-table-column>
        <el-table-column
          :label="$t('DASHBOARD.REL_LEVEL_OF_UND')"
          width="240"
          prop="relative_understanding"
          align="center"
        >
        </el-table-column>

        <el-table-column
          :label="$t('DASHBOARD.ABS_CONCENT_RATE')"
          width="220"
          prop="absolute_concentration"
          align="center"
        >
        </el-table-column>

        <el-table-column
          :label="$t('DASHBOARD.REL_CONCENT_RATE')"
          width="210"
          prop="relative_concentration"
          align="center"
        >
        </el-table-column>

        <el-table-column
          v-if="nextLevel !== undefined"
          label="-"
          width="100"
          align="center"
        >
          <template slot-scope="scope">
            <el-button
              type="primary"
              size="small"
              @click="onClick('DETAILED_ANALYSIS', scope.row)"
            >
              {{ nextLevel }} {{ $t("JOURNALING.ANALYSIS") }}
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <div
        v-if="firstView === '아이템' && firstColumn !== '키워드 이름'"
        style="margin-top : 10px;"
      >
        <el-row>
          <el-col style="width: 100%">
            <el-tabs type="card">
              <el-tab-pane :label="$t('ITEM_FROM_BANK.WHOLE')">
                <el-table
                  v-if="firstView === '아이템'"
                  id="tableData"
                  :data="tableData"
                  style="width: 100%"
                >
                  <el-table-column
                    :label="firstColumn"
                    prop="name"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    v-if="secondColumn !== undefined"
                    :label="secondColumn"
                    :prop="secondProp"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_PRTCP_STATUS')"
                    width="120"
                    prop="absolute_participation"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.RLT_PRTCP_STATUS')"
                    width="120"
                    prop="relative_participation"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_LEVEL_OF_UND')"
                    width="120"
                    prop="absolute_understanding"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_LEVEL_OF_UND')"
                    width="120"
                    prop="relative_understanding"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_CONCENT_RATE')"
                    width="120"
                    prop="absolute_concentration"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_CONCENT_RATE')"
                    width="120"
                    prop="relative_concentration"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    v-if="nextLevel !== undefined"
                    label="-"
                    width="140"
                    align="center"
                  >
                    <template slot-scope="scope">
                      <el-button
                        type="primary"
                        size="small"
                        @click="onClick('DETAILED_ANALYSIS', scope.row)"
                      >
                        {{ nextLevel }} {{ $t("JOURNALING.ANALYSIS") }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-tab-pane>
              <el-tab-pane :label="$t('ITEM.MAIN')">
                <el-table
                  v-if="firstView === '아이템'"
                  id="qustionCurrentType"
                  :data="qustionCurrentType"
                  style="width: 100%"
                >
                  <el-table-column
                    :label="firstColumn"
                    prop="name"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    v-if="secondColumn !== undefined"
                    :label="secondColumn"
                    :prop="secondProp"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_PRTCP_STATUS')"
                    width="120"
                    prop="absolute_participation"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.RLT_PRTCP_STATUS')"
                    width="120"
                    prop="relative_participation"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_LEVEL_OF_UND')"
                    width="120"
                    prop="absolute_understanding"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_LEVEL_OF_UND')"
                    width="120"
                    prop="relative_understanding"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_CONCENT_RATE')"
                    width="120"
                    prop="absolute_concentration"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_CONCENT_RATE')"
                    width="120"
                    prop="relative_concentration"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    v-if="nextLevel !== undefined"
                    label="-"
                    width="140"
                    align="center"
                  >
                    <template slot-scope="scope">
                      <el-button
                        type="primary"
                        size="small"
                        @click="onClick('DETAILED_ANALYSIS', scope.row)"
                      >
                        {{ nextLevel }} {{ $t("JOURNALING.ANALYSIS") }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-tab-pane>
              <el-tab-pane :label="$t('ITEM.PREV')">
                <el-table
                  v-if="firstView === '아이템'"
                  id="qustionPreviewType"
                  :data="qustionPreviewType"
                  style="width: 100%"
                >
                  <el-table-column
                    :label="firstColumn"
                    prop="name"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    v-if="secondColumn !== undefined"
                    :label="secondColumn"
                    :prop="secondProp"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_PRTCP_STATUS')"
                    width="120"
                    prop="absolute_participation"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.RLT_PRTCP_STATUS')"
                    width="120"
                    prop="relative_participation"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_LEVEL_OF_UND')"
                    width="120"
                    prop="absolute_understanding"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_LEVEL_OF_UND')"
                    width="120"
                    prop="relative_understanding"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_CONCENT_RATE')"
                    width="120"
                    prop="absolute_concentration"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_CONCENT_RATE')"
                    width="120"
                    prop="relative_concentration"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    v-if="nextLevel !== undefined"
                    label="-"
                    width="140"
                    align="center"
                  >
                    <template slot-scope="scope">
                      <el-button
                        type="primary"
                        size="small"
                        @click="onClick('DETAILED_ANALYSIS', scope.row)"
                      >
                        {{ nextLevel }} {{ $t("JOURNALING.ANALYSIS") }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-tab-pane>
              <el-tab-pane :label="$t('ITEM.REV')">
                <el-table
                  v-if="firstView === '아이템'"
                  id="qustionReviewType"
                  :data="qustionReviewType"
                  style="width: 100%"
                >
                  <el-table-column
                    :label="firstColumn"
                    prop="name"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    v-if="secondColumn !== undefined"
                    :label="secondColumn"
                    :prop="secondProp"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_PRTCP_STATUS')"
                    width="120"
                    prop="absolute_participation"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.RLT_PRTCP_STATUS')"
                    width="120"
                    prop="relative_participation"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_LEVEL_OF_UND')"
                    width="120"
                    prop="absolute_understanding"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_LEVEL_OF_UND')"
                    width="120"
                    prop="relative_understanding"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    :label="$t('DASHBOARD.ABS_CONCENT_RATE')"
                    width="120"
                    prop="absolute_concentration"
                    align="center"
                  >
                  </el-table-column>
                  <el-table-column
                    :label="$t('DASHBOARD.REL_CONCENT_RATE')"
                    width="120"
                    prop="relative_concentration"
                    align="center"
                  >
                  </el-table-column>

                  <el-table-column
                    v-if="nextLevel !== undefined"
                    label="-"
                    width="140"
                    align="center"
                  >
                    <template slot-scope="scope">
                      <el-button
                        type="primary"
                        size="small"
                        @click="onClick('DETAILED_ANALYSIS', scope.row)"
                      >
                        {{ nextLevel }} 분석
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-tab-pane>
            </el-tabs>
          </el-col>
        </el-row>
      </div>
    </section>
  </div>
</template>

<script>
import XLSX from "xlsx";
import TableExport from "tableexport";
import { saveAs } from "file-saver";
import LineChart from "../partials/NNLineChart";
import analysisService from "../../services/analysisService";
import classService from "../../services/classService";

export default {
  name: "TeacherClassJournal",
  components: {
    LineChart
  },
  data() {
    return {
      query: undefined,
      // level: 'class', // class(과목), lecture(강의), item(아이템)
      // view: 'default', // default, student(학생별), keyword(키워드별), keyword-student(단일 키워드 학생별)
      firstColumn: "세션", // 테이블 첫번째 컬럼 이름
      secondColumn: undefined,
      secondProp: "",
      firstView: "세션", // 첫번째 뷰 버튼에 표시할 내용
      nextLevel: "세션", // 표에서 표시할 다음단계
      className: undefined,
      lectureName: undefined,
      itemName: undefined,
      drawChart: false,
      chartCategories: [],
      chartData: [["이해도"], ["참여도"], ["집중도"]],
      tableData: [],
      drawGraph: false
    };
  },
  async created() {
    const vm = this;
    vm.query = vm.$route.query; // get 파라미터 저장
    vm.secondColumn = undefined; // 두번째 컬럼 기본값 : 표시하지 않음
    vm.drawGraph = false; // 그래프 그리기 기본값 : 그리지 않음
    /* 
    const res0 = await analysisService.getBaseInfo({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId,
      itemId: vm.$route.query.itemId,
    });
    vm.className = res0.data.res.className;
    vm.lectureName = res0.data.res.lectureName;
    vm.itemName = res0.data.res.itemName;

    const res1 = await analysisService.getJournaling({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId,
      itemId: vm.$route.query.itemId,
      view: vm.$route.query.view,
    }); */

    const res0 = await analysisService.getBaseInfo({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId,
      lectureItemId: vm.$route.query.itemId
    });
    // 강의에 대한
    const res1 = await analysisService.getQuestionLecture({
      classId: vm.classId
    });
    // 아이템에 대한
    const res2 = await analysisService.getQuestionItem({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId
    });
    // 본강, 예습, 복습에 대한
    const res3 = await analysisService.getQuestionItemType({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId
    });
    const res4 = await analysisService.getQuestionKeywordClass({
      classId: vm.classId
    });
    vm.className = res0.data.res.className;
    vm.lectureName = res0.data.res.lectureName;
    vm.itemName = res0.data.res.itemName;

    if (vm.$route.query.itemId !== undefined) {
      // 아이템 레벨
      vm.firstView = undefined;
      switch (vm.$route.query.view) {
        case "student": {
          vm.firstColumn = vm.$t("JOURNALING.STUDENT_NAME");
          vm.nextLevel = "학생";
          vm.secondColumn = vm.$t("JOURNALING.STUDENT_MAIL");
          vm.secondProp = "email_id";
          break;
        }
        default: {
          vm.$router.push({
            path: `/a/teacher/class/${vm.classId}/NNjournal`,
            query: { ...vm.query, view: "student" }
          });
        }
      }
    } else if (vm.$route.query.lectureId !== undefined) {
      // 강의 레벨
      vm.firstView = "아이템";
      switch (vm.$route.query.view) {
        case "student": {
          vm.firstColumn = vm.$t("JOURNALING.STUDENT_NAME");
          vm.nextLevel = "학생";
          vm.secondColumn = vm.$t("JOURNALING.STUDENT_MAIL");
          vm.secondProp = "email_id";
          break;
        }
        case "keyword": {
          vm.firstColumn = vm.$t("JOURNALING.KEYWORD_NAME");
          vm.nextLevel = "키워드-학생";
          break;
        }
        case "keyword-student": {
          vm.nextLevel = undefined;
          break;
        }
        default: {
          vm.firstColumn = vm.$t("QUESTION.ITEM_NAME");
          vm.$route.query.view = "default";
          vm.nextLevel = "아이템";
        }
      }
    } else {
      // 과목 레벨
      vm.firstView = vm.$t("JOURNALING.LECTURE");
      vm.firstColumn = vm.$t("JOURNALING.LECTURE_NAME");
      switch (vm.$route.query.view) {
        case "student": {
          vm.firstColumn = vm.$t("JOURNALING.STUDENT_NAME");
          vm.nextLevel = vm.$t("JOURNALING.STUDENT");
          vm.secondColumn = vm.$t("JOURNALING.STUDENT_MAIL");
          vm.secondProp = "email_id";
          break;
        }
        case "keyword": {
          vm.firstColumn = vm.$t("JOURNALING.KEYWORD_NAME");
          vm.nextLevel = vm.$t("JOURNALING.KEY-STU");
          break;
        }
        case "keyword-student": {
          vm.nextLevel = undefined;
          break;
        }
        default: {
          vm.firstColumn = vm.$t("JOURNALING.LECTURE_NAME");
          vm.$route.query.view = "default";
          vm.nextLevel = vm.$t("JOURNALING.LECTURE");
        }
      }
    }

    const classInfo = await classService.getClass({
      id: vm.classId
    });

    // 표 데이터 반영
    vm.tableData = [];
    if (vm.lectureName === undefined && vm.$route.query.view === "default") {
      res1.data.lecture_result.forEach(x => {
        if (x.journaling_type === 1) {
          const tmp = {};
          tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
          tmp.relative_participation = x.relative_participation; // eslint-disable-line
          tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
          tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
          tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
          tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
          tmp.class_id = x.class_id; // eslint-disable-line
          tmp.lecture_id = x.lecture_id; // eslint-disable-line
          tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
          tmp.question_id = x.question_id; // eslint-disable-line
          classInfo.data.lectures.forEach(x => {
            if (x.lecture_id === tmp.lecture_id) {
              tmp.name = x.name; // eslint-disable-line
            }
          });
          vm.tableData.push(tmp);
        }
      });
    } else if (
      vm.lectureName === undefined &&
      vm.$route.query.view === "student"
    ) {
      // 강의별 - 학생별
      res1.data.lecture_result.forEach(x => {
        if (x.journaling_type === 2) {
          const tmp = {};
          tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
          tmp.relative_participation = x.relative_participation; // eslint-disable-line
          tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
          tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
          tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
          tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
          tmp.class_id = x.class_id; // eslint-disable-line
          tmp.lecture_id = x.lecture_id; // eslint-disable-line
          tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
          tmp.question_id = x.question_id; // eslint-disable-line
          tmp.student_id = x.student_id; // eslint-disable-line
          tmp.name = x.user.name; // eslint-disable-line
          tmp.email_id = x.user.email_id; // eslint-disable-line
          vm.tableData.push(tmp);
        }
      });
    } else if (
      vm.itemName === undefined &&
      vm.$route.query.view === "default"
    ) {
      // 아이템별
      res2.data.item_result.forEach(x => {
        if (x.journaling_type === 1) {
          const tmp = {};
          tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
          tmp.relative_participation = x.relative_participation; // eslint-disable-line
          tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
          tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
          tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
          tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
          tmp.class_id = x.class_id; // eslint-disable-line
          tmp.lecture_id = x.lecture_id; // eslint-disable-line
          tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
          tmp.question_id = x.question_id; // eslint-disable-line
          tmp.name = x.lecture_item.name; // eslint-disable-line
          vm.tableData.push(tmp);
        }
      });
    } else if (vm.$route.query.view === "student") {
      // 아이템 - 학생별
      res2.data.item_result.forEach(x => {
        if (x.journaling_type === 2) {
          const tmp = {};
          tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
          tmp.relative_participation = x.relative_participation; // eslint-disable-line
          tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
          tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
          tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
          tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
          tmp.class_id = x.class_id; // eslint-disable-line
          tmp.lecture_id = x.lecture_id; // eslint-disable-line
          tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
          tmp.question_id = x.question_id; // eslint-disable-line
          tmp.student_id = x.student_id; // eslint-disable-line
          tmp.name = x.user.name; // eslint-disable-line
          tmp.email_id = x.user.email_id; // eslint-disable-line
          vm.tableData.push(tmp);
        }
      });
    } else if (vm.lectureName !== undefined) {
      if (vm.$route.query.view === "default") {
        res2.data.item_result.forEach(x => {
          if (x.journaling_type === 1) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.name = x.lecture_item.name; // eslint-disable-line
            vm.tableData.push(tmp);
          }
        });
        res3.data.item_result.forEach(x => {
          if (x.journaling_type === 1 && x.lecture_item.order === 1) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.name = x.lecture_item.name; // eslint-disable-line
            vm.qustionCurrentType.push(tmp);
          } else if (x.journaling_type === 1 && x.lecture_item.order === 0) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.name = x.lecture_item.name; // eslint-disable-line
            vm.qustionPreviewType.push(tmp);
          } else if (x.journaling_type === 1 && x.lecture_item.order === 2) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.name = x.lecture_item.name; // eslint-disable-line
            vm.qustionReviewType.push(tmp);
          }
        });
      } else if (vm.$route.query.view === "student") {
        res2.data.item_result.forEach(x => {
          if (x.journaling_type === 2) {
            const tmp = {};
            let flag = false;
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.student_id = x.student_id; // eslint-disable-line
            tmp.name = x.user.name; // eslint-disable-line
            tmp.email_id = x.user.email_id; // eslint-disable-line
            tmp.count = 1; // eslint-disable-line
            vm.tableData.forEach(y => {
              if (y.student_id === tmp.student_id) {
                flag = true;
                y.absolute_participation =
                  (y.absolute_participation * y.count +
                    tmp.absolute_participation) /
                  (y.count + 1); // eslint-disable-line
                y.relative_participation =
                  (y.relative_participation * y.count +
                    tmp.relative_participation) /
                  (y.count + 1); // eslint-disable-line
                y.absolute_understanding =
                  (y.absolute_understanding * y.count +
                    tmp.absolute_understanding) /
                  (y.count + 1); // eslint-disable-line
                y.relative_understanding =
                  (y.relative_understanding * y.count +
                    tmp.relative_understanding) /
                  (y.count + 1); // eslint-disable-line
                y.absolute_concentration =
                  (y.absolute_concentration * y.count +
                    tmp.absolute_concentration) /
                  (y.count + 1); // eslint-disable-line
                y.relative_concentration =
                  (y.relative_concentration * y.count +
                    tmp.relative_concentration) /
                  (y.count + 1); // eslint-disable-line
                y.count += 1;
              }
            });
            if (flag === false) {
              vm.tableData.push(tmp);
            }
          }
        });
        res3.data.item_result.forEach(x => {
          if (x.journaling_type === 2 && x.lecture_item.order === 1) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.student_id = x.student_id; // eslint-disable-line
            tmp.name = x.user.name; // eslint-disable-line
            tmp.email_id = x.user.email_id; // eslint-disable-line
            vm.qustionCurrentType.push(tmp);
          } else if (x.journaling_type === 2 && x.lecture_item.order === 0) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.student_id = x.student_id; // eslint-disable-line
            tmp.name = x.user.name; // eslint-disable-line
            tmp.email_id = x.user.email_id; // eslint-disable-line
            vm.qustionPreviewType.push(tmp);
          } else if (x.journaling_type === 2 && x.lecture_item.order === 2) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.student_id = x.student_id; // eslint-disable-line
            tmp.name = x.user.name; // eslint-disable-line
            tmp.email_id = x.user.email_id; // eslint-disable-line
            vm.qustionReviewType.push(tmp);
          }
        });
      } else if (vm.$route.query.view === "keyword") {
        // 강의 키워드
        res4.data.item_result.forEach(x => {
          if (
            x.journaling_type === 0 &&
            x.lecture_id === vm.$route.query.lectureId
          ) {
            const tmp = {};
            tmp.name = x.keyword;
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line

            vm.tableData.push(tmp);
          }
        });
      }
    } else {
      if (vm.$route.query.view === "default") {
        res1.data.lecture_result.forEach(x => {
          if (x.journaling_type === 1) {
            const tmp = {};
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.name = x.lecture.name; // eslint-disable-line
            vm.tableData.push(tmp);
          }
        });
      } else if (vm.$route.query.view === "student") {
        res1.data.lecture_result.forEach(x => {
          if (x.journaling_type === 2) {
            const tmp = {};
            let flag = false;
            tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
            tmp.relative_participation = x.relative_participation; // eslint-disable-line
            tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
            tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
            tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
            tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
            tmp.class_id = x.class_id; // eslint-disable-line
            tmp.lecture_id = x.lecture_id; // eslint-disable-line
            tmp.lecture_item_id = x.lecture_item_id; // eslint-disable-line
            tmp.question_id = x.question_id; // eslint-disable-line
            tmp.student_id = x.student_id; // eslint-disable-line
            tmp.name = x.user.name; // eslint-disable-line
            tmp.email_id = x.user.email_id; // eslint-disable-line
            tmp.count = 1; // eslint-disable-line
            vm.tableData.forEach(y => {
              if (y.student_id === tmp.student_id) {
                flag = true;
                y.absolute_participation =
                  (y.absolute_participation * y.count +
                    tmp.absolute_participation) /
                  (y.count + 1); // eslint-disable-line
                y.relative_participation =
                  (y.relative_participation * y.count +
                    tmp.relative_participation) /
                  (y.count + 1); // eslint-disable-line
                y.absolute_understanding =
                  (y.absolute_understanding * y.count +
                    tmp.absolute_understanding) /
                  (y.count + 1); // eslint-disable-line
                y.relative_understanding =
                  (y.relative_understanding * y.count +
                    tmp.relative_understanding) /
                  (y.count + 1); // eslint-disable-line
                y.absolute_concentration =
                  (y.absolute_concentration * y.count +
                    tmp.absolute_concentration) /
                  (y.count + 1); // eslint-disable-line
                y.relative_concentration =
                  (y.relative_concentration * y.count +
                    tmp.relative_concentration) /
                  (y.count + 1); // eslint-disable-line
                y.count += 1; // eslint-disable-line
              }
            });
            if (flag === false) {
              vm.tableData.push(tmp);
            }
          }
        });
      } else {
        // 과목 키워드 평균
        res4.data.item_result.forEach(x => {
          const tmp = {};
          let flag = false;
          tmp.name = x.keyword;
          tmp.absolute_participation = x.absolute_participation; // eslint-disable-line
          tmp.relative_participation = x.relative_participation; // eslint-disable-line
          tmp.absolute_understanding = x.absolute_understanding; // eslint-disable-line
          tmp.relative_understanding = x.relative_understanding; // eslint-disable-line
          tmp.absolute_concentration = x.absolute_concentration; // eslint-disable-line
          tmp.relative_concentration = x.relative_concentration; // eslint-disable-line
          tmp.class_id = x.class_id; // eslint-disable-line
          tmp.lecture_id = x.lecture_id; // eslint-disable-line
          tmp.student_id = x.student_id; // eslint-disable-line
          tmp.count = 1;
          vm.tableData.forEach(y => {
            if (y.name === tmp.name) {
              flag = true;
              y.absolute_participation =
                (y.absolute_participation * y.count +
                  tmp.absolute_participation) /
                (y.count + 1); // eslint-disable-line
              y.relative_participation =
                (y.relative_participation * y.count +
                  tmp.relative_participation) /
                (y.count + 1); // eslint-disable-line
              y.absolute_understanding =
                (y.absolute_understanding * y.count +
                  tmp.absolute_understanding) /
                (y.count + 1); // eslint-disable-line
              y.relative_understanding =
                (y.relative_understanding * y.count +
                  tmp.relative_understanding) /
                (y.count + 1); // eslint-disable-line
              y.absolute_concentration =
                (y.absolute_concentration * y.count +
                  tmp.absolute_concentration) /
                (y.count + 1); // eslint-disable-line
              y.relative_concentration =
                (y.relative_concentration * y.count +
                  tmp.relative_concentration) /
                (y.count + 1); // eslint-disable-line
              y.count++; // eslint-disable-line
            }
          });
          if (flag === false) {
            vm.tableData.push(tmp);
          }
        });
      }
    }

    /* // 차트 데이터 양식으로 변경
    Array.prototype.push.apply(vm.chartCategories, res1.data.res.map(x => x.name));
    Array.prototype.push.apply(vm.chartData[0], res1.data.res.map(x => x.understanding));
    Array.prototype.push.apply(vm.chartData[1], res1.data.res.map(x => x.participation));
    Array.prototype.push.apply(vm.chartData[2], res1.data.res.map(x =>
      (x.concentration !== undefined ? x.concentration : 0)));
    vm.drawGraph = (vm.$route.query.drawGraph === true); // TODO: 번잡함..해소.. */
  },
  methods: {
    async onClick(type, payload) {
      const vm = this;
      switch (type) {
        case "EXPORT_EXCEL": {
          let filename;
          if (vm.itemName !== undefined) {
            filename = `${vm.itemName}_아이템저널링`;
          } else if (vm.lectureName !== undefined) {
            filename = `${vm.lectureName}_세션저널링`;
          } else {
            filename = `${vm.className}_주제저널링`;
          }

          TableExport(document.getElementById("currentTable"), {
            formats: ["xlsx"],
            filename,
            sheetname: "저널링",
            position: "buttom"
          });
          // console.log('echo2 ');
          // const exportData = instance.getExportData().currentTable.xlsx;
          // console.log('instance.getExportData() = ', instance.getExportData());
          // console.log('echo3 ');
          // console.log('exportData = ', exportData);
          // const exportDataMock = [[{v: 'a', t: 's'}, {v: 'c', t: 's'}] , [{v: 'e', t: 's'}, {v: 'g', t: 's'}]]
          // instance.export2file(exportDataMock, 'application/vnd.ms-excel', 'mock_filename', '.xlsx');
          // console.log('echo4 ');
          break;
        }
        case "DRAW_GRAPH": {
          vm.drawGraph = !vm.drawGraph;
          vm.$route.query.drawGraph = vm.drawGraph;
          break;
        }
        case "CHANGE_VIEW": {
          /* if (payload === 'keyword') {
            vm.$notify({
              title: '알림',
              message: '키워드별 보기 : 개발중인 기능입니다.',
              type: 'warning',
              duration: 5000,
            });
            break;
          }*/
          vm.$router.push({
            path: `/a/teacher/class/${vm.classId}/NNjournal`,
            query: {
              ...vm.query,
              view: payload
            }
          });
          break;
        }
        case "DETAILED_ANALYSIS": {
          switch (vm.nextLevel) {
            case "세션": {
              vm.$router.push({
                path: `/a/teacher/class/${vm.classId}/NNjournal`,
                query: {
                  lectureId: payload.lecture_id,
                  view: vm.$route.query.view,
                  drawGraph: vm.drawGraph
                }
              });
              break;
            }
            case "아이템": {
              vm.$router.push({
                path: `/a/teacher/class/${vm.classId}/NNjournal`,
                query: {
                  lectureId: vm.$route.query.lectureId,
                  itemId: payload.lecture_item_id,
                  view: "student",
                  drawGraph: vm.drawGraph
                }
              });
              break;
            }
            default: {
              vm.$notify({
                title: vm.$t("NOTIFY.TITLE"),
                message: vm.$t("TEACHER_CLASS.NOT_PREPARED"),
                type: "warning",
                duration: 5000
              });
            }
          }
          break;
        }
        default: {
          throw new Error("unexpected type: ", type);
        }
      }
    },
    async exportExcel({ sheetName, fileName }) {
      const vm = this;
      const wb = XLSX.utils.table_to_book(
        document.getElementById("currentTable"),
        { sheet: sheetName }
      );
      const wbout = XLSX.write(wb, {
        bookType: "xlsx",
        bookSST: true,
        type: "binary"
      });
      XLSX.write(wb, { bookType: "xlsx", bookSST: true, type: "binary" });
      saveAs(
        new Blob([vm.s2ab(wbout)], { type: "application/octet-stream" }),
        `${fileName}.xlsx`
      );
    },
    s2ab(s) {
      const buf = new ArrayBuffer(s.length);
      const view = new Uint8Array(buf);
      for (let i = 0; i < s.length; i += 1) {
        view[i] = s.charCodeAt(i) && 0xff;
      }
      return buf;
    }
  },
  computed: {
    classId() {
      return this.$route.params.classId;
    }
  }
};
</script>

<style scoped>
/* nav {
  min-width: 250px;
}
#labelName {
  display: flex;
}
.selected-lecture {
  opacity: 40%;
}
section {
  min-width: 800px;
  width: 100%;
  margin: 35px 15px 0 25px;
}
section > div {
  padding-top: 10px;
}
#topLabel {
  width: initial;
  display: flex;
  justify-content: space-between;
  align-items: center;
}
#subjectJournaling {
  display: flex;
  width: 100%;
}
#excelExport {
  padding: 12px;
  margin-right: 50px;
  background: #4366ac;
  color: #fff;
} */

body {
  margin: 0px;
}
nav {
  float: left;
  width: 250px;
  height: 100%;
  background: #4366ac;
  color: #fff;
}
#logo {
  padding: 20px 0 20px 0;
  text-align: center;
}
#logo > p {
  font-size: 25px;
  font-weight: bold;
  font-family: "Roboto", sans-serif;
}
#profile {
  padding: 20px;
}
#profile1 img {
  float: left;
  margin: 5px;
}
#profile1 > p {
  margin: 5px 0 5px 0;
}
#profile2 {
  text-align: right;
}
#profile2 > p {
  text-decoration: underline;
}
#profile2 p:nth-child(1) {
  float: left;
  margin: 0;
}
#navList {
  list-style: none;
  margin: 0;
}
#navList img {
  vertical-align: middle;
}
section {
  float: left;
}

nav {
  min-width: 250px;
}
#labelName {
  display: flex;
}
.selected-lecture {
  opacity: 40%;
}
section {
  min-width: 800px;
  width: 100%;
  margin: 35px 15px 0 25px;
}
section > div {
  padding-top: 10px;
}
#topLabel {
  width: initial;
  display: flex;
  justify-content: space-between;
  align-items: center;
}

.bt-container {
  display: flex;
  width: 100%;
}
#excelExport {
  padding: 12px;
  margin-right: 50px;
  background: #4366ac;
  color: #fff;
}
</style>
